Attribute VB_Name = "mAssociateFile"
Option Explicit

Private Declare Function RegCreateKey Lib "advapi32.dll" Alias "RegCreateKeyA" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Private Declare Function RegSetValue Lib "advapi32.dll" Alias "RegSetValueA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal dwType As Long, ByVal lpData As String, ByVal cbData As Long) As Long

' Return codes from Registration functions.
Const ERROR_SUCCESS = 0&
Const ERROR_BADDB = 1&
Const ERROR_BADKEY = 2&
Const ERROR_CANTOPEN = 3&
Const ERROR_CANTREAD = 4&
Const ERROR_CANTWRITE = 5&
Const ERROR_OUTOFMEMORY = 6&
Const ERROR_INVALID_PARAMETER = 7&
Const ERROR_ACCESS_DENIED = 8&

Private Const HKEY_CLASSES_ROOT = &H80000000
Private Const MAX_PATH = 260&
Private Const REG_SZ = 1

Public Sub AssociateFile(sAppName As String, sFileDesc As String, sAppPath As String, ParamArray asExtension())

'handle to key created by RegCreateKey
Dim lhKey As Long

'create root entry for application/file type
RegCreateKey HKEY_CLASSES_ROOT, sAppName, lhKey
RegSetValue lhKey, "", REG_SZ, sFileDesc, 0

'set app cmd line
RegCreateKey HKEY_CLASSES_ROOT, sAppName, lhKey
RegSetValue lhKey, "shell\open\command", REG_SZ, sAppPath, MAX_PATH

'associate extensions
Dim i As Integer
For i = 0 To UBound(asExtension)
  RegCreateKey HKEY_CLASSES_ROOT, asExtension(i), lhKey
  RegSetValue lhKey, "", REG_SZ, sAppName, 0
Next i

End Sub

